local addon = CreateFrame("Frame", "dMinimap", Minimap)

-- hide those nasty buttons
local frames = {
	MinimapZoomIn,
	MinimapZoomOut,
	MinimapToggleButton,
	MinimapBorderTop,
	MiniMapWorldMapButton,
	MinimapBorder,
}

---------------------------- CONFIGURATION ------------------------------
local anchorpoint = 'BOTTOMRIGHT' -- default TOPLEFT
local parent = UIParent
local relativepoint = 'BOTTOMRIGHT' -- default TOPLEFT
local xpos = -44 -- default 36
local ypos = 44 -- default -36
local scale = 1 -- textures wont scale with it so i recommend 0.8, otherwise you have to adjust width/height for textures, manually
local minimapshape = "square" -- square or round shape of minimap
local classcolors = false -- true = classcolors, false = custom color (see the line below)
local bliptex = 1  -- 1 = changes the track (blip) texture to a new one, 0 = uses Blizzards default textures
-- NOTE: If you change bliptex from 1 to 0 you have to relog to make the change happen, /consoloe reloadui or /rl won't be enough

-- change round border texture here (default = round5) -- round, round2, round3, round4, round5, round6	
local roundtex = "Interface\\AddOns\\dMinimap\\texture\\round7.tga"

-- change square border texture here (default = square2) -- square, square2, square3, square4, square5, square6	
local squaretex = "Interface\\AddOns\\dMinimap\\texture\\square2.tga"

------------------------- bordercolorz --------------------------- 
-- only called if classcolors = false - R G B Color Codes - december.com/html/spec/colorcodes.html
-- each value can be anything between 0.00 and 1

--local bordercolorz = {0.4,0.4,0.4} 
--local bordercolorz = {0.9,0.9,0.9}
local bordercolorz = {0.6,0.6,0.6}
--local bordercolorz = {0.2,0.2,0.2}
--local bordercolorz = {0.35,0.3,0.3} 
--local bordercolorz = {0.69,0.09,0.12}

---------------------------  position of PvP tracker --------------------------- 
local PosWTracker = false -- true = enable positioning of the PvP tracker, false = disable positioning of the PvP tracker
-- NOTE: If you change PosWTracker from true to false you have to relog to make the change happen, /consoloe reloadui or /rl won't be enough

local Wpos = "TOP"
local Wpos_x = 0
local Wpos_y = -50

---------------------------- END OF CONFIGURATION ------------------------------


---------------------------- Zone text (on mouseover) ------------------------------
	Minimap:SetScript("OnEnter", function() MinimapZoneTextButton:Show() end)
	Minimap:SetScript("OnLeave", function() MinimapZoneTextButton:Hide() end)
	MinimapZoneText:SetPoint("TOP", Minimap, 0, 40)
	MinimapZoneTextButton:Hide()
	MinimapZoneText:SetTextColor(1,1,1)
	
---------------------------- Quest tracker ------------------------------
if PosQTracker == true then
local quest = QuestWatchFrame
quest:ClearAllPoints()
quest:SetPoint(Qpos, UIParent, Qpos_x, Qpos_y)
quest.SetPoint = function() end	
end

---------------------------- textures and stuff ------------------------------
local r, g, b = NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b
local event = function(self)

	Minimap:EnableMouseWheel(true)
	Minimap:SetScript("OnMouseWheel", function(self, z)
		local c = Minimap:GetZoom()
		if(z > 0 and c < 5) then
			Minimap:SetZoom(c + 1)
		elseif(z < 0 and c > 0) then
			Minimap:SetZoom(c - 1)
		end
	end)

---------------------------- square shape ------------------------------	
	if minimapshape == "square" then 
		function GetMinimapShape() return "SQUARE" end
		Minimap:SetMaskTexture"Interface\\AddOns\\dMinimap\\texture\\Mask.blp"

		local ssf = CreateFrame("Frame")
		ssf:SetParent(Minimap)
		ssf:ClearAllPoints()
		ssf:SetPoint("CENTER",Minimap,0,0)
		ssf:SetWidth(172)
		ssf:SetHeight(172)
		ssf:SetFrameLevel(2)
		local squareshape = ssf:CreateTexture(nil,"BACKGROUND")

		-- change square border texture here (default = square2) -- square, square2, square3, square4	
		squareshape:SetTexture(squaretex)

		squareshape:SetAllPoints(ssf)
		squareshape:SetAlpha(0.9)
		if classcolors == true then
			local r, g, b
			local class = select(2, UnitClass('player'))
			if class then
				r = RAID_CLASS_COLORS[class].r
				g = RAID_CLASS_COLORS[class].g
				b = RAID_CLASS_COLORS[class].b
			end
			squareshape:SetVertexColor(r, g, b,1)
			elseif classcolors == false then
			squareshape:SetVertexColor(unpack(bordercolorz))
		end
			
		MiniMapBattlefieldBorder:Hide()
		MiniMapBattlefieldFrame:SetParent(Minimap)
		MiniMapBattlefieldFrame:ClearAllPoints()
		MiniMapBattlefieldFrame:SetPoint("TOPRIGHT", 0, -3)

		local mmmf = MiniMapMailFrame
		mmmf:SetParent(Minimap)
		mmmf:ClearAllPoints()
		mmmf:SetPoint("TOP",Minimap, 0, 2)
		mmmf:SetScale(1.5)
		
		MiniMapMailBorder:Hide()
		MiniMapMailIcon:SetTexture"Interface\\AddOns\\dMinimap\\texture\\mail"

		
		local fmi = Minimap:CreateTexture(nil,"Overlay")
		fmi:SetTexture("Interface\\AddOns\\dMinimap\\texture\\minimap")
		fmi:SetPoint("TOPLEFT", Minimap, "TOPLEFT", -3, 2)
		fmi:SetPoint("BOTTOMRIGHT", Minimap, "BOTTOMRIGHT", 3, 0)
		fmi:SetVertexColor(1, 1, 1)

---------------------------- round shape ------------------------------		
		elseif minimapshape == "round" then 
		function GetMinimapShape() return "ROUND" end
		Minimap:SetMaskTexture"Interface\\AddOns\\dMinimap\\texture\\Mask-ROUND.tga"

		MiniMapBattlefieldBorder:Hide()
		MiniMapBattlefieldFrame:SetParent(Minimap)
		MiniMapBattlefieldFrame:ClearAllPoints()
		MiniMapBattlefieldFrame:SetPoint("BOTTOMLEFT",Minimap,-25,0)

		local mmmf = MiniMapMailFrame
		mmmf:SetParent(Minimap)
		mmmf:ClearAllPoints()
		mmmf:SetPoint("LEFT",Minimap,-35,0) -- default ( -40, 0)
		mmmf:SetScale(2.0)
		
		MiniMapMailBorder:Hide()
		MiniMapMailIcon:SetTexture"Interface\\AddOns\\dMinimap\\texture\\mail"
		
		local rsf = CreateFrame("Frame")
		rsf:SetParent(Minimap)
		rsf:ClearAllPoints()
		rsf:SetPoint("CENTER",Minimap,0,0)
		rsf:SetWidth(177)
		rsf:SetHeight(177)
		rsf:SetFrameLevel(2)
		local roundshape = rsf:CreateTexture(nil,"OVERLAY")

		roundshape:SetTexture(roundtex)
		
		roundshape:SetAllPoints(rsf)
		roundshape:SetAlpha(1)
		if classcolors == true then
			local r, g, b
			local class = select(2, UnitClass('player'))
			if class then
				r = RAID_CLASS_COLORS[class].r
				g = RAID_CLASS_COLORS[class].g
				b = RAID_CLASS_COLORS[class].b
			end
			roundshape:SetVertexColor(r, g, b,1)
			elseif classcolors == false then
			roundshape:SetVertexColor(unpack(bordercolorz))
		end
	
		local fmi = Minimap:CreateTexture(nil,"Overlay")
		fmi:SetParent(Minimap)
		fmi:ClearAllPoints()
		fmi:SetPoint("CENTER",Minimap,0,0)		
		fmi:SetTexture("Interface\\AddOns\\dMinimap\\texture\\GlowRoundShape")
		fmi:SetWidth(178)
		fmi:SetHeight(178)		
		fmi:SetVertexColor(1, 1, 1)
	end

---------------------------- track (blip) texture ------------------------------
	if bliptex == 0 then
		Minimap:SetBlipTexture"Interface\\AddOns\\dMinimap\\texture\\track"
	end

	for _, frame in pairs(frames) do
		frame:Hide()
	end
	frames = nil
end

---------------------------- calendar frame ------------------------------
-- hide it and let it show on right minimap click, tracking on middle click 
-- code from BasicMinimap by funkydude

	GameTimeFrame:Hide()
	GameTimeFrame:UnregisterAllEvents()
	GameTimeFrame.Show = kill

	MiniMapTracking:Hide()
	MiniMapTracking.Show = kill
	MiniMapTracking:UnregisterAllEvents()

	Minimap:SetScript("OnMouseUp", function(self, btn)
		if btn == "RightButton" then
			_G.GameTimeFrame:Click()
		elseif btn == "MiddleButton" then
			_G.ToggleDropDownMenu(1, nil, _G.MiniMapTrackingDropDown, self)
		else
			_G.Minimap_OnClick(self)
		end
	end)

-- calendar slashcmd
SlashCmdList["CALENDAR"] = function()
	ToggleCalendar()
end
SLASH_CALENDAR1 = "/cl"
SLASH_CALENDAR2 = "/calendar"
	
-- functions
Minimap:ClearAllPoints()
Minimap:SetPoint(anchorpoint, parent, relativepoint, xpos, ypos)
Minimap:SetScale(scale)

  ---------------------------------------------------
  -- Make it moveable 
  ---------------------------------------------------

  	Minimap:RegisterForDrag("LeftButton")
	Minimap:SetClampedToScreen(true)
	Minimap:SetMovable(true)
	Minimap:SetScript("OnDragStart", function(self) if IsShiftKeyDown() and IsAltKeyDown() then self:StartMoving() end end)
	Minimap:SetScript("OnDragStop", function(self) if IsShiftKeyDown() and IsAltKeyDown() then self:StopMovingOrSizing() end end)

Minimap:SetFrameStrata("LOW")
addon:SetScript("OnEvent", event)
addon:RegisterEvent"PLAYER_LOGIN"